<template>
  <div class="block-content">
    <form>
      <div class="form-content">
        <label class="form-label">City</label>
        <input type="text" class="form-value" id="city" v-model="city.city"/>
      </div>
      <div class="err" id="city-err">
        <p style="color: red;">City name shouldn't contain numbers</p>
      </div>
      <div class="form-content">
        <label class="form-label">Region</label>
        <select class="form-value" id='sel' v-model="city.regionId">
          <option selected>---------</option>
          <option v-for="region in regions" :key="region.id" :item="region"
          :value="region.id" v-on:click="city.regionId = region.id">
            {{region.region}}
          </option>
        </select>
      </div>
      <div class="err" id="reg-err">
        <p style="color: red;">Please, select one value</p>
      </div>
      <div class="form-content">
        <input type="button" value="Submit and new" class="form-button"
        v-on:click="submit('City')" />
        <input type="button" value="Submit" class="form-button"
        id="righter" v-on:click="submit('Cities')" />
      </div>
    </form>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'City',
  props: {
    object: Number,
  },
  data() {
    return {
      regions: [],
      city: {},
    };
  },
  mounted() {
    this.getRegion();
    this.getCity();
  },
  methods: {
    getRegion() {
      axios.get('http://localhost:4000/api/regions').then(
        (result) => {
          this.regions = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    getCity() {
      if (this.object > 0) {
        axios.get(`http://localhost:4000/api/cities/${this.object}`).then(
          (result) => {
            this.city = result.data;
          },
        ).catch((error) => {
          console.log(error);
        });
      }
    },
    validateCity(obj) {
      const reg = /.*\d.*/;
      if (obj.city && !reg.test(obj.city)
        && obj.regionId) {
        return true;
      }
      if (!obj.city || reg.test(obj.city)) {
        document.getElementById('city').style.borderColor = 'red';
        document.getElementById('city-err').style.display = 'block';
      }
      if (!obj.regionId) {
        document.getElementById('sel').style.borderColor = 'red';
        document.getElementById('reg-err').style.display = 'block';
      }

      return false;
    },
    submit(component) {
      if (this.object === 0) {
        if (this.validateCity(this.city)) {
          axios.post('http://localhost:4000/api/cities', {
            city: this.city.city,
            regionId: this.city.regionId,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
        }
        this.nullify();
        this.$emit('object', 0);
      } else {
        if (this.validateCity(this.city)) {
          axios.patch(`http://localhost:4000/api/cities/${this.object}`, {
            city: this.city.city,
            regionId: this.city.regionId,
          })
            .then((response) => { console.log(response); alert('sukcesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
        }
        this.$emit('change-component', component);
        this.$emit('object', 0);
      }
    },
    nullify() {
      document.getElementById('city').value = '';
    },
  },
};
</script>

<style scoped>
@import "../CSS/actionObject.css";
</style>
